%{
/*
	                 <calcul1.y>
		Calculette:		Analyse Syntaxique.
*/

#include	"calcul.h"
#define		vu(a)	printf ("%s", a);
#define		genereaux1	printf ("\n\ncode instruction"		\
					"\n\tresultat"			\
					"\n\t\t1er operande"		\
					"\n\t\t\t2eme operande\n\n");	\
				printf ("---\t---\t---\t---\t---\t---\n");

#define	genere(a,b,c,d) printf ("\n%d\t%d\t%d\t%d",a,b,c,d);
/* ---------------------------------------------------------------------- */
%}

%token		F
%token		variable
%token		valeur
%left		'+' '-'
%left		'*' '/'
%start		essai
%%
/* ---------------------------------------------------------------------- */
terme	:	F '(' formule ')'
	{
	$$ = TailleDic;
	TailleDic++;
	switch ($1)
		{
		case	its_sinus:	
			{
			$$ = TailleDic;
			TailleDic++;
			genere (its_sinus,  $$, $3, 0);
			}
			break;

		case	its_cosinus:
			{
			$$ = TailleDic;
			TailleDic++;
			genere (its_cosinus, $$, $3, 0);
			}
			break;
		}
	}
	;

formule	:	formule '+' formule
	{
	$$ = TailleDic;
	TailleDic++;
	genere (its_add,	$$, $1,$3);
	}
	|	formule '-' formule
	{
	$$ = TailleDic;
	TailleDic++;
	genere (its_sub,	$$, $1,$3);
	}
	|	formule '*' formule
	{
	$$ = TailleDic;
	TailleDic++;
	genere (its_mul,	$$, $1,$3);
	}
	|	formule '/' formule
	{
	$$ = TailleDic;
	TailleDic++;
	genere (its_div,	$$, $1,$3);
	}
	|	terme
	{
	$$ = $1;
	}
	|	variable
	{
	$$ = $1;
	}
	|	valeur
	{
	$$ = $1;
	}
	|	'(' formule ')'
	{
	$$ = $2;
	}
	;

ligne	:	variable '=' formule '\n' 
	{
	genere (its_aff,	$1, $3, 0);
	genereaux1;
	}
	|	'\n'
	{
	}
	;

essai	:	essai	ligne
	|	ligne
	;
%%
/* ---------------------------------------------------------------------- */
int	main	(int argc, char * argv[])
{
	int	rc;

	printf	("\nPetit compilateur sans branchements dans le code:\n");
	rc = yyparse ();
	printf	("\nCode retour de 'yyparse()':%d\n\n", rc);

	printf	("\n\n\tContenu du dictionnaire de donnees:\n\n");
	for	(rc = 0; rc < TailleDic; rc++)
	{
		printf ("\t%f\t%s\n", Dic[rc].v, Dic[rc].n);
	}
}